﻿Module Module1
  Sub Main()
    Dim argCount As Integer =
      My.Application.CommandLineArgs.Count

    If argCount = 1 OrElse argCount = 2 Then
      Dim arg1 =
        My.Application.CommandLineArgs.Item(0)
      If arg1(0) = "-" Then
        Select Case arg1(1)
          Case "t"
            If argCount = 2 Then
              Dim sw As New Stopwatch
              sw.Start()

              ShowFiles(
                My.Application.CommandLineArgs.Item(1))
              Console.Error.WriteLine(
                "showfile command finished (" &
                sw.ElapsedMilliseconds.ToString() &
                " msec)")
            Else
              ShowUsage()
            End If
          Case "v"
            ShowVersion()
          Case Else
            ShowUsage()
        End Select
      Else
        ShowFiles(arg1)
      End If
    Else
      ShowUsage()
    End If
  End Sub

  Sub ShowUsage()
    Console.WriteLine(
      "usage: showfiles [options] target_directory" &
      vbCrLf &
      "options: -v display version information" &
      vbCrLf &
      "         -t display elapsed time")
  End Sub

  Sub ShowVersion()
    Console.WriteLine(
      "showfiles by VB Version " &
      My.Application.Info.Version.ToString() &
      "(2011/09/06)" & vbCrLf &
      My.Application.Info.Copyright.ToString() &
      " All rights reserved")
  End Sub

  Sub ShowFiles(target As String)
    If System.IO.Directory.Exists(target) Then
      Dim files() As String = {}
      Dim directories() As String = {}
      Try
        directories =
          System.IO.Directory.GetDirectories(target)
        For Each directory As String In directories
          ShowFiles(directory)
        Next
        files = System.IO.Directory.GetFiles(target)
      Catch ex As Exception
        Console.WriteLine("error: " &
          ex.Message.ToString())
      End Try

      For Each file As String In files
        Console.WriteLine(file)
      Next
    Else
      Console.WriteLine("error: """ & target &
        """ is not a valid directory")
    End If
  End Sub

  'Sub ShowFiles(target As String)
  '  If System.IO.Directory.Exists(target) Then
  '    Dim files() As String = {}
  '    Try
  '      files = System.IO.Directory.GetFiles(
  '        target, "*", IO.SearchOption.AllDirectories)
  '    Catch ex As Exception
  '      Console.WriteLine("error: " &
  '        ex.Message.ToString())
  '    End Try
  '    For Each file As String In files
  '      Console.WriteLine(file)
  '    Next
  '  Else
  '    Console.WriteLine("error: """ & target &
  '      """ is not a valid directory")
  '  End If
  'End Sub
End Module
