﻿Module Module1
  Sub Main()
    If My.Application.CommandLineArgs.Count = 1 Then
      Dim arg1 =
        My.Application.CommandLineArgs.Item(0)
      If arg1(0) = "-" Then
        If arg1(1) = "v" Then
          ShowVersion()
        Else
          ShowUsage()
        End If
      Else
        Console.WriteLine(FindExecutable(arg1))
      End If
    Else
      ShowUsage()
    End If
  End Sub

  Sub ShowUsage()
    Console.WriteLine(
      "usage: which [options] commandname" & vbCrLf &
      "options: -v display version information")
  End Sub

  Sub ShowVersion()
    Console.WriteLine(
      "which by VB Version " &
      My.Application.Info.Version.ToString() &
      "(2011/09/06)" & vbCrLf &
      My.Application.Info.Copyright.ToString() &
      " All rights reserved")
  End Sub

  Function FindExecutable(keyword As String) As String
    If -1 <> keyword.IndexOf("."c) Then _
      Return "error: the keyword includes dot(.)"

    Dim path As String =
      My.Application.GetEnvironmentVariable("path")
    path = Environment.CurrentDirectory &
      ";" & path
    Dim paths() As String = path.Split({";"c})
    Dim executableExtensions() As String =
      {".COM", ".EXE", ".BAT", ".CMD"}

    Dim possibleFilenames(
      executableExtensions.Count) As String
    Dim ucaseKeyword As String = UCase(keyword)
    For i As Integer = 0 To _
      executableExtensions.Count - 1

      possibleFilenames(i) =
        ucaseKeyword & executableExtensions(i)
    Next

    For Each s As String In paths
      Dim files() As String =
        System.IO.Directory.GetFiles(s)
      For Each t As String In files
        Dim filename As String =
          UCase(System.IO.Path.GetFileName(t))
        For Each pfn As String In possibleFilenames
          If pfn = filename Then Return t
        Next
      Next
    Next

    Return "cannot find """ & keyword & """"
  End Function
End Module
